
VdpIn_Data equ &98
VdpIn_Status equ &99

VdpOut_Data equ &98
VdpOut_Control equ &99
VdpOut_Palette equ &9A
VdpOut_Indirect equ &9B





VDP_SetScreenMode4:
	ld a,%00000110		;6 - set graphics screen mode bits
	out (VdpOut_Control),a
	ld a,128+0		;[ 0 ] [DG ] [IE2] [IE1] [M5] [M4] [M3] [ 0 ]
	out (VdpOut_Control),a
	
	ld a,%01100000  ; Enable Screen - Enable Retrace Interrupt
	out (VdpOut_Control),a
	ld a,128+1	;R#1  [ 0 ] [BL ] [IE0] [M1 ] [ M2] [ 0 ] [SI ] [MAG] 
	out (VdpOut_Control),a
	
	
	
	ld a,31
	out (VdpOut_Control),a
	ld a,128+2		;Pattern layout table
	out (VdpOut_Control),a
	
	ld a,239
	out (VdpOut_Control),a
	ld a,128+5		; Sprite Attrib Table Low
	out (VdpOut_Control),a
	
	ld a,%11110001	;7
	out (VdpOut_Control),a
	ld a,128+7		;Text and screen margin color
	out (VdpOut_Control),a
	
	ld a,128
	out (VdpOut_Control),a
	ld a,128+10		;Color Table High (Shrug)
	out (VdpOut_Control),a
	
	ld a,%00001010		;Set up Vram (Shrug!) [VR=1] [SPD=SpriteDisable] 
	out (VdpOut_Control),a
	ld a,128+8		;R#8  [MS ] [LP ] [TP ] [CB ] [VR ] [ 0 ] [SPD] [BW ] 
	out (VdpOut_Control),a

	ld a,%00000000 	;[LN ]=1 212 lines / [LN ]=0 = 192 lines
	out (VdpOut_Control),a
	ld a,128+9	        ;R#9  [LN ] [ 0 ] [S1 ] [S0 ] [IL ] [E0 ] [*NT] [DC ]
	out (VdpOut_Control),a
ret


VDP_Wait:

	;Get The status register - Disable interrupts!
	ld a,2			;S#2  [TR ] [VR ] [HR ] [BD ] [ 1 ] [ 1 ] [EO ] [CE ] - Status register 2
	out (VdpOut_Control),a
	ld a,128+15		;R#15  [ 0 ] [ 0 ] [ 0 ] [ 0 ] [S3 ] [S2 ] [S1 ] [S0 ] - Set Stat Reg to read
	out (VdpOut_Control),a

VDP_DoWait:
	in a,(VdpIn_Status)	;S#2  [TR ] [VR ] [HR ] [BD ] [ 1 ] [ 1 ] [EO ] [CE ] - Status register 2
	bit 0,a
	ret z
	jp VDP_DoWait

VDP_FirmwareSafeWait:
	di
	call VDP_Wait
	call VDP_GetStatusFirwareDefault
	ei
ret

VDP_GetStatusFirwareDefault:
xor a
jr VDP_GetStatusRegisterB
VDP_GetStatusRegister:
	;Get The status register - Disable interrupts!
	ld a,2			;S#2  [TR ] [VR ] [HR ] [BD ] [ 1 ] [ 1 ] [EO ] [CE ] - Status register 2
VDP_GetStatusRegisterB:
	out (VdpOut_Control),a
	ld a,128+15		;R#15  [ 0 ] [ 0 ] [ 0 ] [ 0 ] [S3 ] [S2 ] [S1 ] [S0 ] - Set Stat Reg to read
	out (VdpOut_Control),a
ret

VDP_STOP:
	;Set the autoinc for more data
	ld a,0
	out (VdpOut_Control),a		
	ld a,128+46
	out (VdpOut_Control),a
ret


VDP_HMMM_BusyCheck:
	in a,(VdpIn_Status)	;S#2  [TR ] [VR ] [HR ] [BD ] [ 1 ] [ 1 ] [EO ] [CE ] - Status register 2
	bit 0,a
	jr nz,VDP_HMMM_BusyCheck
VDP_HMMM:	;(High speed move VRAM to VRAM) (Blit Bytes)
;	ld hl,MyHMMM

	;Set the autoinc for more data
	ld a,32				;AutoInc From 36
	out (VdpOut_Control),a		
	ld a,128+17			;R#17  [AII] [ 0 ] [R5 ] [R4 ] [R3 ] [R2 ] [R1 ] [R0 ] 		Indirect Register 128=no inc
	out (VdpOut_Control),a



	ld c,VdpOut_Indirect
	;outi x 15
	defb &ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3
ret
VDP_MyHMMM:
VDP_MyHMMM_SX:	defw &0000 ;SY 32,33
VDP_MyHMMM_SY:	defw &0000 ;SY 34,35
VDP_MyHMMM_DX:	defw &0060 ;DX 36,37
VDP_MyHMMM_DY:	defw &0060 ;DY 38,39
VDP_MyHMMM_NX:	defw &0040 ;NX 40,41 
VDP_MyHMMM_NY:	defw &0040 ;NY 42,43
		defb 0     ;Color 44 - unused
VDP_MyHMMM_MV:	defb 0     ;Move 45
		defb %11010000 ;Command 46	







VDP_HMMC_Generated_BusyCheck:
	in a,(VdpIn_Status)	;S#2  [TR ] [VR ] [HR ] [BD ] [ 1 ] [ 1 ] [EO ] [CE ] - Status register 2
	bit 0,a
	jr nz,VDP_HMMC_Generated_BusyCheck
VDP_HMMC_Generated:			;Fill ram from calculated values (first in A)
;	ld hl,MyHMMC		 (High speed move CPU to VRAM) (Blit Bytes from OUTI)


	;Set the autoinc for more data
	ld a,36				;AutoInc From 36
	out (VdpOut_Control),a		
	ld a,128+17			;R#17  [AII] [ 0 ] [R5 ] [R4 ] [R3 ] [R2 ] [R1 ] [R0 ] 		Indirect Register 128=no inc
	out (VdpOut_Control),a


	ld c,VdpOut_Indirect
;	outi X 11
	defb &ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3

	;Set the autoinc for more data
	ld a,128+44			;128 = NO Increment ;R#44    Color byte
	out (VdpOut_Control),a		
	ld a,128+17			;R#17  [AII] [ 0 ] [R5 ] [R4 ] [R3 ] [R2 ] [R1 ] [R0 ] 		Indirect Register
	out (VdpOut_Control),a
ret




VDP_MyHMMC:
VDP_MyHMMC_DX:	defw &0000 ;DX 36,37
VDP_MyHMMC_DY:	defw &0000 ;DY 38,39
VDP_MyHMMC_NX:	defw &0032 ;NX 40,41
VDP_MyHMMC_NY:	defw &0032 ;NY 42,43
VDP_MyHMMCByte:	defb 255   ;Color 44
	defb 0     ;Move 45
	defb %11110000 ;Command 46	


VDP_HMMV_BusyCheck:
	in a,(VdpIn_Status)	;S#2  [TR ] [VR ] [HR ] [BD ] [ 1 ] [ 1 ] [EO ] [CE ] - Status register 2
	bit 0,a
	jr nz,VDP_HMMC_Generated_BusyCheck
VDP_HMMV:	
;	ld hl,MyHMMV		;HMMV (High speed move VDP to VRAM) (Flood Fill Byte)


VDP_OutFrom36:
	ld a,36				;AutoInc From 36
	out (VdpOut_Control),a		
	ld a,128+17			;R#17  [AII] [ 0 ] [R5 ] [R4 ] [R3 ] [R2 ] [R1 ] [R0 ] 		Indirect Register 128=no inc
	out (VdpOut_Control),a

	ld c,VdpOut_Indirect
	defb &ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3,&ED,&A3
ret



VDP_MyHMMV:	
VDP_MyHMMV_DX:	defw &0000 ;DX 36,37
VDP_MyHMMV_DY:	defw &0000 ;DY 38,39
VDP_MyHMMV_NX:	defw &0100 ;NX 40,41
VDP_MyHMMV_NY:	defw &00C0 ;NY 42,43
VDP_MyHMMV_Byte:defb 64   ;Color 44
		defb 0     ;Move 45
		defb %11000000 ;Command 46	






VDP_SetPalette:

;;;;;;;;;;;;;;;;;;;;;;;;;;;
; palette setup

;	R#16  [ 0 ] [ 0 ] [ 0 ] [ 0 ] [C3 ] [C2 ] [C1 ] [C0 ]  - Set AutoInc Palette reg	ister
;	Port #2 first byte  0  R2  R1  R0  0  B2  B1  B0 	Data 1   - Red data  Blue data 
;	Port #2 second byte 0  0   0   0   0  G2  G1  G0 	Data 2 	- Green data 	
;	
	
	ld a,0				;Set First Pallete to change
	out (VdpOut_Control),a
	ld a,128+16			;Copy Value to Register 16 (Palette)
	out (VdpOut_Control),a
	ld b,16
VDP_morepal:
	ld a,(hl)
	inc hl
	out (VdpOut_Palette),a
	ld a,(hl)
	inc hl
	out (VdpOut_Palette),a
	djnz VDP_morepal
	

ret

VDP_bmpProcessor:
	;HL/BC = Filename
	;IX = dest Xpos 
	;IY = dest Ypos 
	ld (VDP_MyHMMC_DX),ix
	ld (VDP_MyHMMC_DY),iy

	xor a
	ld (VDP_NotFirstRunFlag_Plus1-1),a
	ld iy,VDP_bmpProcessorAgain
	jp LoadDiscSectorSpecialMSX

VDP_bmpProcessorAgain:
	di


	
	ld a,0 :VDP_NotFirstRunFlag_Plus1
	or a
	jp nz,VDP_bmpProcessor_NotFirstRun	
	inc a
	ld (VDP_NotFirstRunFlag_Plus1-1),a




	ld a,(hl)	;File format
	inc hl
;	push af
;		ld hl,&0000
;		ld (VDP_MyHMMC_DX),hl
;		ld (VDP_MyHMMC_DY),hl

		ld e,(hl)
		inc hl
		ld d,(hl)
		inc hl

		ld (VDP_BmpWidth_Plus2-2),de
		ld (VDP_MyHMMC_NX),de

		ld e,(hl)
		inc hl
		ld d,(hl)
		inc hl

		ld (VDP_BmpHeight_Plus2-2),de		
		ld (VDP_MyHMMC_NY),de

;	pop af 

	or a
	jr z,VDP_bmpProcessor_BmpNoPalette
;	ex hl,de
		call VDP_SetPalette
;	ex hl,de
VDP_bmpProcessor_BmpNoPalette:


		ld a,(hl)
		inc hl
		ld (VDP_MyHMMCByte),a
		ex hl,de
		ld hl,VDP_MyHMMC
		call VDP_HMMC_Generated

push de
	ld ix,DiskBuffer_End
	ld a,d
	cpl
	ld d,a
	ld a,e
	cpl
	ld e,a
	inc de
	add ix,de
pop de
VDP_bmpProcessor_HMMC:
	ld hl,00 :VDP_BmpHeight_Plus2
VDP_bmpProcessor_HMMC_NextLine:
	ld bc,00 :VDP_BmpWidth_Plus2
VDP_bmpProcessor_HMMC_NextByte:

	ld a,(de)
	inc de
	out (VdpOut_Indirect),a
	dec ixl
	jp z,VDP_bmpProcessor_Done


	dec bc
	ld a,b
	or c
	jp nz,VDP_bmpProcessor_HMMC_NextByte
	dec hl
	ld a,h
	or l
	jp nz,VDP_bmpProcessor_HMMC_NextLine
ret
VDP_bmpProcessor_NotFirstRun:
	ex hl,de
 ld ixh,b
 ld ixl,c

ld bc,0000 :VDP_bmpProcessor_BCRestore_Plus2
ld hl,0000 :VDP_bmpProcessor_HLRestore_Plus2
jp VDP_bmpProcessor_HMMC_NextByte

VDP_bmpProcessor_Done:
	ld (VDP_bmpProcessor_BCRestore_Plus2-2),bc
	ld (VDP_bmpProcessor_HLRestore_Plus2-2),HL
ret