﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Bitmap bmpZoom;
        public Int16[,,] spritepixel;
        public Int16[, ,] SpeccyPaletteF;   //foreground
        public Int16[, ,] SpeccyPaletteB;   //Background
        public Int16[, ,] SpeccyPaletteL;   //Lightness


        public Int16[, ,] Bak_spritepixel;
        public Int16[, ,] Bak_SpeccyPaletteF;   //foreground
        public Int16[, ,] Bak_SpeccyPaletteB;   //Background
        public Int16[, ,] Bak_SpeccyPaletteL;   //Lightness
        int NextBackup = -1;
        int CurrentBackup = -1;
        public Label[] ColorSelector;
        public Label[,] SpeccySelector;
        public Label SpeccySample;
        public PictureBoxWithInterpolationMode  PicZoom;
        public Int16 colorLeft = 15;
        public Int16 colorRight = 0;
        public Int16 SpeccyColorFore = 7;
        public Int16 SpeccyColorBack = 0;
        public Int16 SpeccyColorBright = 0;
        public int CurrentSprite = 0;
        public Int16 [] Spr_Wid;
        public Int16 [] Spr_Hei;
        public Int16 [] Spr_MinX;
        public Int16 [] Spr_MinY;
        public Int16[] Spr_Xoff;
        public Int16[] Spr_Yoff;
        public int SpriteCount;
        public Color[] Speccypalettedark = { Color.Black, Color.DarkBlue, Color.DarkRed, Color.DarkMagenta, Color.Green, Color.DarkCyan, Color.YellowGreen, Color.DarkGray, Color.DarkGray, Color.LightGray };
        public Color[] Speccypalette = { Color.Black, Color.Blue, Color.Red, Color.Magenta, Color.Lime, Color.Cyan, Color.Yellow, Color.White, Color.DarkGray, Color.LightGray };
        public int backuptimer = 0;

        public Form1()
        {
            InitializeComponent();
            bmpZoom = new Bitmap(257, 257);
            // spritepixel = new Int16[64, 256, 256];
            // SpeccyPaletteF = new Int16[64, 32, 32];
            //SpeccyPaletteB = new Int16[64, 32, 32];
            //SpeccyPaletteL = new Int16[64, 32, 32];
            ClearSprites();
            Bak_spritepixel = new Int16[10,256, 256];
            Bak_SpeccyPaletteF = new Int16[10, 32, 32];
            Bak_SpeccyPaletteB = new Int16[10, 32, 32];
            Bak_SpeccyPaletteL = new Int16[10, 32, 32];


            Spr_Wid= new Int16[64];
            Spr_Hei= new Int16[64];
            Spr_MinX = new Int16[64];
            Spr_MinY = new Int16[64];
            Spr_Xoff = new Int16[64];
            Spr_Yoff = new Int16[64];
            ColorSelector = new Label[19];
            SpeccySelector = new Label[11, 2];

            
            PicZoom = new PictureBoxWithInterpolationMode();
            PicZoom.Padding = new Padding(0, 0,0,0);
            PicZoom.Top = 0;
            PicZoom.Left = 0;
            PicZoom.Anchor = AnchorStyles.Top | AnchorStyles.Left;
            
            
            PicZoom.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
            PicZoom.MouseMove += new MouseEventHandler(PicZoom_Drag);
            PicZoom.MouseDown += new MouseEventHandler(PicZoom_Drag);

            panel1.Controls.Add(PicZoom);
            PicZoom.Image = bmpZoom;
            picPreview.Image = bmpZoom;
            PicZoom.SizeMode = PictureBoxSizeMode.Zoom;
            
            for (int i = 0; i <= 63; i++) {
                lstSprites.Items.Add(VbX.Right("00"+i.ToString(),2)+" ");
            }
            lstSprites.SelectedIndex = 0;
            for (int i = 0; i < 19; i++)
            {



                ColorSelector[i] = new Label();
                ColorSelector[i].BorderStyle = BorderStyle.FixedSingle;
                if (i < 16)
                {
                    ColorSelector[i].BackColor = Color.FromArgb(255, i * 16, i * 16, i * 16);
                }
                ColorSelector[i].Name = "Colorselector_" + i.ToString();
                if (i == 16) ColorSelector[i].BackColor = Color.FromArgb(255, 255, 0, 255);
                if (i == 17) ColorSelector[i].BackColor = Color.FromArgb(255, 255, 255, 255);
                if (i == 18) ColorSelector[i].BackColor = Color.FromArgb(255, 0, 0, 0);

                ColorSelector[i].Width = 32;
                ColorSelector[i].Height = 32;
                ColorSelector[i].Top = 0;
                ColorSelector[i].Left = i * 32;
                if (i >= 17) ColorSelector[i].Left += 16;
                ColorSelector[i].MouseDown += new MouseEventHandler(ColorSelector_MouseDown);
                tabEditor.Controls.Add(ColorSelector[i]);
            }
                for (int i = 0; i <= 10; i++)
            {

                Label sp = new Label();
                sp.BorderStyle = BorderStyle.FixedSingle;

                sp.Name = "SpeccyBack_" + i.ToString();

                if (i == 8) sp.Name = "SpeccyDark";
                if (i == 9) sp.Name = "SpeccyLight";
                if (i < 10)
                {
                    sp.BackColor = Speccypalette[i];
                }
                
                
                
                sp.Width = 32;
                sp.Height = 24;
                sp.Top = 0;

                if (i >= 8) sp.Top += 12;
                sp.Left = i * 32+ColorSelector[18].Left;
                sp.Left += 32+16;
                sp.MouseDown += new MouseEventHandler(SpeccySelector_MouseDown);
                tabEditor.Controls.Add(sp);
                SpeccySelector[i, 0] = sp;
                if (i < 8)
                {
                    sp = new Label();
                    sp.BorderStyle = BorderStyle.FixedSingle;


                    sp.BackColor = Speccypalette[i];

                    sp.Name = "SpeccyFore_" + i.ToString();

                    sp.Width = 32;
                    sp.Height = 24;
                    sp.Top = 24;
                    sp.Left = i * 32 + ColorSelector[18].Left;
                    sp.Left += 32 + 16;
                    sp.MouseDown += new MouseEventHandler(SpeccySelector_MouseDown);
                    tabEditor.Controls.Add(sp);
                    SpeccySelector[i, 1] = sp;
                }
            }
                SpeccySampleUpdate();


                btnRefresh_Click(null,null);
            trkzoom.Value = 4;
            doscale(trkzoom.Value);
        }
        private void doscale(int scale) {
            //PicZoom.zoom = scale;
            PicZoom.Width = 256 * scale;
            PicZoom.Height = 256 * scale;
        }

        private void ResetBackupTimer() {
            backuptimer = 0;
            tmrBackup.Enabled = true;
            lblBackupTaken.Text = "!";
        }
       
        private void RepaintArea(int x, int y) {

            int xx = x / 8;
            int yy = y / 8;
            xx = xx * 8;
            yy = yy * 8;
            for (int ax = xx; ax < xx + 8; ax++)
            {
                for (int ay = yy; ay < yy + 8; ay++)
                {
                    RepaintPixel(ax, ay);
                }
            }

        
        }
        private void RepaintPixel(int x, int y) {

            int gridcol1 = 56/2;
            int gridcol2 = 64 / 2;
            int gridcol3 = 80 / 2;
            if (chkStrongGrid.Checked) {
                gridcol1 = 56;
                gridcol2 = 64;
                gridcol3 = 80;
            
            }

            Int16 pen = spritepixel[CurrentSprite,x, y];

            if (rdoDisplayCPC.Checked && pen < 16)
            {
                int p = pen;
                if (p>3) p = p % 3+1;
                pen = ((Int16)p);
            }

            
            int r=ColorSelector[pen].BackColor.R;
            int g = ColorSelector[pen].BackColor.G;
            int b = ColorSelector[pen].BackColor.B;

            if (rdoDisplaySpeccy.Checked && pen<16) // apply the spectrum effect!
            {
                int specb = SpeccyPaletteB[CurrentSprite, x / 8, y / 8];
                int specf = SpeccyPaletteF[CurrentSprite, x / 8, y / 8];
                if (SpeccyPaletteL[CurrentSprite, x / 8, y / 8] == 0)
                {
                    if (pen == 0)
                    {
                        r = Speccypalettedark[specb].R;
                        g = Speccypalettedark[specb].G;
                        b = Speccypalettedark[specb].B;
                    }
                    else
                    {
                        r = Speccypalettedark[specf].R;
                        g = Speccypalettedark[specf].G;
                        b = Speccypalettedark[specf].B;
                    }
                }
                else
                {
                    if (pen == 0)
                    {
                        r = Speccypalette[specb].R;
                        g = Speccypalette[specb].G;
                        b = Speccypalette[specb].B;
                    }
                    else
                    {
                        r = Speccypalette[specf].R;
                        g = Speccypalette[specf].G;
                        b = Speccypalette[specf].B;
                    }
                }

            } // End of spectrum palette tweaks

            int rx = 0;
            int gx = 0;
            int bx = 0;




            if (!rdoGuideNone.Checked)
            {

                if (((x / 8) % 2) == 0) rx = gridcol2;
                if (((y / 8) % 2) == 0)
                {
                    if (rx == gridcol2) rx = 0; else rx = gridcol2;
                }


                if (rdoGuide4_8_24.Checked)
                {
                    if (((x / 24) % 2) == 0) gx = gridcol1;
                    if (((y / 24) % 2) == 0)
                    {
                        if (gx == 0) gx = gridcol1; else gx = 0;
                    }
                }

                if (rdoGuide4_8_32.Checked)
                {
                    if (((x / 32) % 2) == 0) gx = gridcol1;
                    if (((y / 32) % 2) == 0)
                    {
                        if (gx == 0) gx = gridcol1; else gx = 0;
                    }
                }


                if (((x / 4) % 2) == 0) bx = gridcol3;
            }              



            r = (int)(((double)r) * 1)+rx;
            g = (int)(((double)g) * 1)+gx;
            b = (int)(((double)b) * 1)+bx;


            
            if (r>255) r=255;
            if (g>255) g=255;
            if (b>255) b=255;

            bmpZoom.SetPixel(x+1,y+1,Color.FromArgb(255, r, g, b));
        }

        private Int16 checkerize(int x,int y,Int16 col1,Int16 col2,int pattern){
            int c = 1;
            if (pattern == 1)
            {
                if (x % 2 == 1) c = 1 - c;
                if (y % 2 == 1) c = 1 - c;
            }
            if (pattern == 2)
            {
                if (x % 2 == y % 4 && y % 2==1) c = 1 - c;
            }
            if (c==1) return col1; else return col2;

        }

        private void PicZoom_Drag(object sender, EventArgs e)
        {
            
            int chkr = 0;
            chkr=VbX.CInt(btnChecker.Text.Replace("ck ",""));
            var mouseEventArgs = e as MouseEventArgs;
            if (mouseEventArgs != null)
            {
                float scale = trkzoom.Value;
                float halfscale = scale / 2;
                float fx = (mouseEventArgs.X - halfscale)* 256;
                float fy = (mouseEventArgs.Y - halfscale )* 256;
                fx = fx / (255 * scale);
                fy = fy / (255 * scale);
                
                int x = (int)fx;//((mouseEventArgs.X - halfscale)) / scale;
                int y = (int)fy;//((mouseEventArgs.Y - halfscale)) / scale;

              //  VbX.MsgBox(mouseEventArgs.X.ToString());
              if (x>255) x=255;
              if (y > 255) y= 255;


                //x=x-1;
                //y=y-1;
                if (x < 0 || y < 0 || x >255 || y >255 ) return;
                if (mouseEventArgs.Button==MouseButtons.Left)
                    
                    {

                        float rx = (mouseEventArgs.X - halfscale) * 256;
                        float ry = (mouseEventArgs.Y - halfscale) * 256;
                        rx = rx / (255 * scale)-x;
                        ry = ry / (255 * scale)-y;
                        if ((ry < .20 || ry > .80 || rx < .20 || rx > .80) && scale>=3)
                        {   // didn't hit center
                          //  VbX.MsgBox(rx.ToString() + " " + ry.ToString());
                            return;
                        }

                        ResetBackupTimer();
                    if (btnZXpaint.Text != "zx B")
                        {
                            spritepixel[CurrentSprite, x, y] = checkerize(x, y, colorLeft, colorRight, chkr);
                        }

                    
                        if (btnZXpaint.Text == "zx N" || btnZXpaint.Text == "zx B")
                        {
                        SpeccyPaletteF[CurrentSprite, x/8, y/8] = SpeccyColorFore;
                        SpeccyPaletteB[CurrentSprite, x/8, y/8] = SpeccyColorBack;
                        SpeccyPaletteL[CurrentSprite, x/8, y/8] = SpeccyColorBright;
                    }

                            RepaintArea(x, y);

                        //bmpZoom.SetPixel(x,y,Color.FromArgb(255, 255, 255, 0));
                        PicZoom.Image = bmpZoom;
                        picPreview.Image = bmpZoom;
                    }
                if (mouseEventArgs.Button == MouseButtons.Right)
                {
                    ResetBackupTimer();
                    spritepixel[CurrentSprite, x, y] = checkerize(x, y, colorRight, colorLeft, chkr); ;
                    RepaintArea(x, y);

                 //   bmpZoom.SetPixel(x, y, Color.FromArgb(255, 0, 0, 0));
                    PicZoom.Image = bmpZoom;
                    picPreview.Image = bmpZoom;
                }

 
            }
        }
        private void SpeccySelector_MouseDown(object sender, EventArgs e)
        {
            var mouseEventArgs = e as MouseEventArgs;
            Int16 i = (Int16)VbX.CInt(ss.GetItem(((Label)sender).Name, "_", 1));
            String cmd = ss.GetItem(((Label)sender).Name, "_", 0);

            if (i == 10) {
                i = SpeccyColorBack;
                SpeccyColorBack = SpeccyColorFore;
                SpeccyColorFore = i;
                SpeccySampleUpdate();
                return;
            }


            switch (cmd)
            {
                case "SpeccyBack":
                    SpeccyColorBack = i;
                    break;
                case "SpeccyFore":
                    SpeccyColorFore = i;
                    break;
                case "SpeccyDark":
                    SpeccyColorBright = 0;
                    break;
                case "SpeccyLight":
                    SpeccyColorBright = 1;
                    break;

            }

            SpeccySampleUpdate();

        }
        private void SpeccySampleUpdate() { 
            Label sample=SpeccySelector[10,0];
           if (SpeccyColorBright==0){
               sample.BackColor = Speccypalettedark[SpeccyColorBack];
               sample.ForeColor = Speccypalettedark[SpeccyColorFore];
           }
           if (SpeccyColorBright == 1)
           {
               sample.BackColor = Speccypalette[SpeccyColorBack];
               sample.ForeColor = Speccypalette[SpeccyColorFore];
           }

           sample.Text = "ABC";
           sample.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
        }
        private void ColorSelector_MouseDown(object sender, EventArgs e)
        {
            Int16 i = (Int16)VbX.CInt(ss.GetItem(((Label)sender).Name, "_", 1));
            if (btnSetPal.Text.Substring(0, 1) == "[") { //redefine this color
                ColorDialog colorDlg = new ColorDialog();
                colorDlg.FullOpen = true;
         
                if (colorDlg.ShowDialog() == DialogResult.OK)
                {
                     ColorSelector[i].BackColor = colorDlg.Color;
                }
                return;
            }


            if (btnColorSwap.Text.Substring(0, 1) == "[") {
                Togglebutton(btnColorSwap);
                int chkr = 0;
                chkr = VbX.CInt(btnChecker.Text.Replace("ck ", ""));
                for (int x = 0; x < 256; x++) {
                    for (int y = 0; y < 256; y++)
                    {
                        if (spritepixel[CurrentSprite, x, y] == i)
                        {
                            spritepixel[CurrentSprite, x, y] = checkerize(x, y, colorLeft, colorRight, chkr);
                        }
                    }
                }
                btnRefresh_Click(sender, e);
                return;

            }


            var mouseEventArgs = e as MouseEventArgs;
            
            if (mouseEventArgs.Button == MouseButtons.Right) {
                colorRight = i;
                ColorSelector[18].BackColor = ColorSelector[i].BackColor;
            }
            if (mouseEventArgs.Button == MouseButtons.Left)
            {
                colorLeft = i;
                ColorSelector[17].BackColor = ColorSelector[i].BackColor;
            }
            
        }
    

        private void trkzoom_Scroll(object sender, EventArgs e)
        {
            doscale(trkzoom.Value);
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {


                for (int x = 0; x < 256; x++)
                    for (int y = 0; y < 256; y++)
                    {
                        RepaintPixel(x, y);
                       
                    }
            PicZoom.Image = bmpZoom;
            picPreview.Image = bmpZoom;
            SpriteStats(CurrentSprite);
            lblSpriteInfo.Text = "(" + Spr_MinX[CurrentSprite].ToString() + "," + Spr_MinY[CurrentSprite].ToString() + ") - (" + Spr_Wid[CurrentSprite].ToString() + "," + Spr_Hei[CurrentSprite].ToString() + ")";
            lblSpriteInfo.Text += VbX.Chr(13) + VbX.Chr(10) + "Sprites:" + SpriteCount.ToString();

            lblMaxSpritesByOffset.Text = VbX.CStr(VbX.Val(txtSpriteDataOffSet.Text) / 6);
            

        }
        private void SpriteStats(int i)
        {
            Spr_Wid[i] = 0;
            Spr_Hei[i] = 0;
            Spr_MinX[i] = 256;
            Spr_MinY[i] = 256;
            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {
                    RepaintPixel(x, y);
                    if (spritepixel[i, x, y] != 0)
                    {
                        if (x >= Spr_Wid[i]) Spr_Wid[i] = (Int16)(x + 1);
                        if (y >= Spr_Hei[i]) Spr_Hei[i] = (Int16)(y + 1);
                        if (x < Spr_MinX[i]) Spr_MinX[i] = (Int16)x;
                        if (y < Spr_MinY[i]) Spr_MinY[i] = (Int16)y;
                        if ((i + 1) > SpriteCount) SpriteCount = i + 1;
                    }

                }
            }

        }


        private void lstSprites_SelectedIndexChanged(object sender, EventArgs e)
        {
            CurrentSprite = VbX.Val(ss.GetItem(lstSprites.Text, " ", 0));
            if (this.Visible==true)            btnRefresh_Click(sender, e);
            ForceBackup();
        }

        private void lstSprites_Click(object sender, EventArgs e)
        {
            
        }

        private void btnSavePal_Click(object sender, EventArgs e)
        {
          
        }
        private void btnSave_Click(object sender, EventArgs e)
        {
           
        }

        private void btnSetPal_Click(object sender, EventArgs e)
        {
            if (btnSetPal.Text.Substring(0, 1) == "[")
            {
                btnSetPal.Text = "SetPal";
            }
            else {
                btnSetPal.Text = "[SetPal]";
            }
        }

        private void rdoDisplayMSX_CheckedChanged(object sender, EventArgs e)
        {
            btnRefresh_Click(sender, e);
        }

        private void rdoDisplayCPC_CheckedChanged(object sender, EventArgs e)
        {
            btnRefresh_Click(sender, e);
        }

        private void rdoDisplaySpeccy_CheckedChanged(object sender, EventArgs e)
        {
            btnRefresh_Click(sender, e);
        }

        private void btnZXpaint_Click(object sender, EventArgs e)
        {
            switch (btnZXpaint.Text){
                case "zx N":
                    btnZXpaint.Text = "zx F";
                    break;
                case "zx F":
                    btnZXpaint.Text = "zx B";
                    break;
                case "zx B":
                    btnZXpaint.Text = "zx N";
                    break;

            }
        }

   

        private void btnChecker_Click(object sender, EventArgs e)
        {
            switch (btnChecker.Text)
            {
                case "ck 0":
                    btnChecker.Text = "ck 1";
                    break;
                case "ck 1":
                    btnChecker.Text = "ck 2";
                    break;
                case "ck 2":
                    btnChecker.Text = "ck 0";
                    break;


            }
        }

        private void btnColorSwap_Click(object sender, EventArgs e)
        {
            Togglebutton(btnColorSwap);
        }
        private void Togglebutton(Button b) {
            if (b.Text.Substring(0, 1) == "[")
            {
                b.Text = b.Text.Replace("[", "").Replace("]", "");
            }
            else
            {
                b.Text = "[" + b.Text + "]";
            }
        }
        private void ForceBackup() {
            backuptimer = 99999;
            tmrBackup.Enabled = true;
        }

        private void tmrBackup_Tick(object sender, EventArgs e)
        {
            
            backuptimer += 100;
            if (backuptimer>2000){
                backuptimer = 0;
                lblBackupTaken.Text = " ";
                tmrBackup.Enabled = false;
                
                CurrentBackup = CurrentBackup + 1;
                if (CurrentBackup >= 10) CurrentBackup = 0;
                MakeBackup(CurrentBackup);
                
                NextBackup = CurrentBackup;
            }
        }

        private void MakeBackup(int i){
            
                for (int x=0;x<256;x++){
                    for (int y=0;y<256;y++){
                        Bak_spritepixel[i,x,y]=spritepixel[CurrentSprite,x,y];
                    }
                    
                    
                }
            for (int x=0;x<32;x++){
                    for (int y=0;y<32;y++){
                        Bak_SpeccyPaletteF[i,x,y]=SpeccyPaletteF[CurrentSprite,x,y];
                        Bak_SpeccyPaletteB[i,x,y]=SpeccyPaletteB[CurrentSprite,x,y];
                        Bak_SpeccyPaletteL[i,x,y]=SpeccyPaletteL[CurrentSprite,x,y];
                    }
           }
        }

        private void btnUndo_Click(object sender, EventArgs e)
        {
            int cb = CurrentBackup;
            CurrentBackup -= 1;
            if (CurrentBackup < 0) CurrentBackup = 9;
            if (CurrentBackup == NextBackup)
            {
                CurrentBackup = cb;
                return;
            }
            RestoreBackup(CurrentBackup);
        }
        private void RestoreBackup(int i)
        {

            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {
                    spritepixel[CurrentSprite, x, y]=Bak_spritepixel[i, x, y]  ;
                }

            }
            for (int x = 0; x < 32; x++)
            {
                for (int y = 0; y < 32; y++)
                {
                    SpeccyPaletteF[CurrentSprite, x, y]=Bak_SpeccyPaletteF[i, x, y] ;
                    SpeccyPaletteB[CurrentSprite, x, y]=Bak_SpeccyPaletteB[i, x, y] ;
                    SpeccyPaletteL[CurrentSprite, x, y]=Bak_SpeccyPaletteL[i, x, y];
                }
            }
            btnRefresh_Click(null, null);
        }

        private void btnRedo_Click(object sender, EventArgs e)
        {
            if (CurrentBackup==NextBackup) return;
            CurrentBackup += 1;
            if (CurrentBackup > 9) CurrentBackup = 0;
            RestoreBackup(CurrentBackup);
        }

        private void btnLastSprite_Click(object sender, EventArgs e)
        {
            SaveSpriteDetails(-1);
            if (lstSprites.SelectedIndex == 0) return;
            lstSprites.SelectedIndex = lstSprites.SelectedIndex - 1;
            CurrentSprite = VbX.Val(ss.GetItem(lstSprites.Text, " ", 0));
            if (this.Visible == true) btnRefresh_Click(sender, e);
            ForceBackup();
        }

        private void btnNextSprite_Click(object sender, EventArgs e)
        {
            SaveSpriteDetails(-1);
            // if (lstSprites.SelectedIndex == 0) return;
            lstSprites.SelectedIndex = lstSprites.SelectedIndex + 1;
            CurrentSprite = VbX.Val(ss.GetItem(lstSprites.Text, " ", 0));
            if (this.Visible == true) btnRefresh_Click(sender, e);
            ForceBackup();
        }

        private void SaveSpriteDetails(int s) {

          if (s==-1) s=lstSprites.SelectedIndex;
            string spritedescr = s.ToString()+ " ";
            spritedescr+=Spr_Wid[s].ToString()+"x";
            spritedescr+=Spr_Hei[s].ToString()+"   ";
            spritedescr+=Spr_MinX[s].ToString()+"/";
            spritedescr+=Spr_MinY[s].ToString();
            spritedescr += Spr_Hei[s].ToString() + "   ";
            spritedescr += Spr_Xoff[s].ToString() + "/";
            spritedescr += Spr_Yoff[s].ToString();
            lstSprites.Items[s] = spritedescr;


        }
        private void ClearSprites() {
            txtSpriteDataOffSet.Text = "&180";
            spritepixel = new Int16[64, 256, 256];
            SpeccyPaletteF = new Int16[64, 32, 32];
            SpeccyPaletteB = new Int16[64, 32, 32];
            SpeccyPaletteL = new Int16[64, 32, 32];

            for (int s = 0; s < 64; s++) {
                for (int x = 0; x < 32; x++) {
                    for (int y = 0; y < 32; y++)
                    {
                        SpeccyPaletteF[s, x, y]=7;
                        SpeccyPaletteB[s, x, y]=0;
                        SpeccyPaletteL[s, x, y]=1;
                    }
                }
            }

        }

        private void btnSaveCpc_Click(object sender, EventArgs e)
        {
         
        }





        private void loadSpectrumScreenToolStripMenuItem_Click(object sender, EventArgs e)
        {
             OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "Speccy Screen (*.scr)|*.scr";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;
            ClearSprites();
            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Open, System.IO.FileAccess.Read);

            System.IO.BinaryReader BR = new System.IO.BinaryReader(ST);
            byte b = 0;
            if (chkHasDosHeader.Checked)
            {
                for (int i = 0; i < 128; i++)
                {
                    //skip header
                    b = BR.ReadByte();
                }
            }
            int yy = 0;
            int x=0;

            for (int by = 0; by < (256 * 192) / 8; by++) {
                int y1=yy%8*8;
                int y2 = (yy % 64) / 8;
                int y3 = (yy / 64)*64;
                int y = y1+y2+y3;

                b = BR.ReadByte();
                int b1 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(0, 1));
                int b2 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(1, 1));
                int b3 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(2, 1));
                int b4 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(3, 1));
                int b5 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(4, 1));
                int b6 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(5, 1));
                int b7 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(6, 1));
                int b8 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(7, 1));
                spritepixel[CurrentSprite, x + 0, y] = (Int16)b1;
                spritepixel[CurrentSprite, x + 1, y] = (Int16)b2;
                spritepixel[CurrentSprite, x + 2, y] = (Int16)b3;
                spritepixel[CurrentSprite, x + 3, y] = (Int16)b4;
                spritepixel[CurrentSprite, x + 4, y] = (Int16)b5;
                spritepixel[CurrentSprite, x + 5, y] = (Int16)b6;
                spritepixel[CurrentSprite, x + 6, y] = (Int16)b7;
                spritepixel[CurrentSprite, x + 7, y] = (Int16)b8;
                x = x + 8;
                if (x == 256){ x = 0; yy++;}
            }
            for (int y2 = 0; y2 < 24; y2++)
            {
                for (int x2 = 0; x2 < 32; x2++)
                
                {
                    b = BR.ReadByte();
                    int b1 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(1, 1));
                    int b2 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(2, 3));
                    int b3 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(5, 3));
                 
                    SpeccyPaletteB[CurrentSprite, x2, y2] = (Int16)b2;
                    SpeccyPaletteF[CurrentSprite, x2, y2] = (Int16)b3;
                    SpeccyPaletteL[CurrentSprite, x2, y2] = (Int16)b1;

                }
            }




            BR.Close();
            VbX.MsgBox("Loaded");
            rdoDisplaySpeccy.Checked = true;
            btnRefresh_Click(sender, e);
        }

        private void saveSpectrumBinaryToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "ZXS Binary Sprite (*.SPR)|*.SPR";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;


            int firstspritepos = VbX.Val(txtSpriteDataOffSet.Text);
            for (int s = 0; s < 64; s++)
            {
                SpriteStats(s);         // update all our info on the sprites
            }





            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Create, System.IO.FileAccess.Write);

            System.IO.BinaryWriter BW = new System.IO.BinaryWriter(ST);
            byte b = 0;
            int bytepos = 0;
            int thisspritebytepos = firstspritepos;

            for (int s = 0; s < SpriteCount; s++)
            {
                BW.Write((Byte)Spr_Hei[s]);
                BW.Write((Byte)((Spr_Wid[s] + 3) / 8));
                BW.Write((Byte)Spr_Yoff[s]);
                BW.Write((Byte)Spr_Xoff[s]);

                Int16 mp = (Int16)(thisspritebytepos);
                int thisspritesize = ((Spr_Hei[s] - Spr_MinY[s]) * ((Spr_Wid[s] + 7) / 8));
                thisspritesize += (((Spr_Hei[s] - (Spr_MinY[s]) + 7) / 8) * ((Spr_Wid[s] + 7) / 8));
                thisspritebytepos = thisspritebytepos + thisspritesize;
                BW.Write(mp);
                bytepos += 6;
            }
            while (bytepos < firstspritepos)
            {
                bytepos++;
                BW.Write((Byte)(0));
            }




            for (int spritenum = 0; spritenum < SpriteCount; spritenum++)
            {
                for (int y = Spr_MinY[spritenum]; y < Spr_Hei[spritenum]; y++)
                {
                    for (int x = 0; x < Spr_Wid[spritenum]; x += 8)
                    {
                        int sp1 = spritepixel[spritenum, x, y];
                        int sp2 = spritepixel[spritenum, x + 1, y];
                        int sp3 = spritepixel[spritenum, x + 2, y];
                        int sp4 = spritepixel[spritenum, x + 3, y];
                        int sp5 = spritepixel[spritenum, x + 4, y];
                        int sp6 = spritepixel[spritenum, x + 5, y];
                        int sp7 = spritepixel[spritenum, x + 6, y];
                        int sp8 = spritepixel[spritenum, x + 7, y];


                        if (sp4 == 16 && sp3 == 16 && sp2 == 16 && sp1 == 16 && sp5 == 16 && sp6 == 16 && sp7 == 16 && sp8 == 16)
                        {
                            int transpcol = VbX.Bin2Dec(VbX.Right(VbX.Dec2Bin8Bit(Spr_Xoff[spritenum]), 3));
                            if (transpcol == 5)
                            {
                                sp1 = 0;
                                sp2 = 1;
                                sp3 = 0;
                                sp4 = 1;
                                sp5 = 0;
                                sp6 = 1;
                                sp7 = 0;
                                sp8 = 1;
                            }
                            if (transpcol == 4)
                            {
                                sp1 = 1;
                                sp2 = 0;
                                sp3 = 1;
                                sp4 = 0;
                                sp5 = 1;
                                sp6 = 0;
                                sp7 = 1;
                                sp8 = 0;
                            }
                        }
                        if (sp1 == 16) sp1 = 0;
                        if (sp2 == 16) sp2 = 0;
                        if (sp3 == 16) sp3 = 0;
                        if (sp4 == 16) sp4 = 0;
                        if (sp5 == 16) sp5 = 0;
                        if (sp6 == 16) sp6 = 0;
                        if (sp7 == 16) sp7 = 0;
                        if (sp8 == 16) sp8 = 0;

                        if (sp1 > 1) sp1 = 1;
                        if (sp2 > 1) sp2 = 1;
                        if (sp3 > 1) sp3 = 1;
                        if (sp4 > 1) sp4 = 1;
                        if (sp5 > 1) sp5 = 1;
                        if (sp6 > 1) sp6 = 1;
                        if (sp7 > 1) sp7 = 1;
                        if (sp8 > 1) sp8 = 1;

                        string tbyte = "";

                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp3).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp4).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp5).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp6).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp7).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp8).Substring(7, 1);





                        BW.Write((Byte)VbX.Bin2Dec(tbyte));



                    }
                }
                for (int y = ((Spr_MinY[spritenum] + 7) / 8); y < ((Spr_Hei[spritenum] + 7) / 8); y++)
                {
                    for (int x = 0; x < ((Spr_Wid[spritenum] + 7) / 8); x++)
                    {
                        string tbyte = "0"; //flashing is bad -mkay!
                        tbyte += VbX.Dec2Bin8Bit(SpeccyPaletteL[spritenum, x, y]).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(SpeccyPaletteB[spritenum, x, y]).Substring(5, 3);
                        tbyte += VbX.Dec2Bin8Bit(SpeccyPaletteF[spritenum, x, y]).Substring(5, 3);
                        BW.Write((Byte)VbX.Bin2Dec(tbyte));

                    }
                }
            }

            BW.Close();
            ST.Close();
            //VbX.MsgBox("Saved");
            tabControl1.SelectedTab = tabControl1.TabPages[0];

            btnRefresh_Click(sender, e);
        }

        private void saveMSXASMPaletteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "MSX Palette ASM Code (*.txt)|*.txt";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;

            string nl = VbX.Chr(13) + VbX.Chr(10);
            System.IO.StreamWriter SR = new System.IO.StreamWriter(fd.FileName, false, Encoding.ASCII);


            for (int i = 0; i < 16; i++)
            {
                //db %00000000,%00000000 ;-RRR-BBB,-----GGG
                SR.Write("defb ");
                SR.Write("%0" + VbX.Dec2Bin8Bit(ColorSelector[i].BackColor.R).Substring(0, 3));
                SR.Write("0" + VbX.Dec2Bin8Bit(ColorSelector[i].BackColor.B).Substring(0, 3));
                SR.Write(",%00000" + VbX.Dec2Bin8Bit(ColorSelector[i].BackColor.G).Substring(0, 3));
                SR.Write(";" + VbX.CStr(i) + "  -RRR-BBB,-----GGG");
                SR.Write(nl);
            }

            SR.Close();
            tabControl1.SelectedTab = tabControl1.TabPages[0];
        }

        private void saveMSXBinaryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "MSX Binary Sprite (*.SPR)|*.SPR";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;


            int firstspritepos = VbX.Val(txtSpriteDataOffSet.Text);
            for (int s = 0; s < 64; s++)
            {
                SpriteStats(s);         // update all our info on the sprites
            }





            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Create, System.IO.FileAccess.Write);

            System.IO.BinaryWriter BW = new System.IO.BinaryWriter(ST);
            byte b = 0;
            int bytepos = 0;
            int thisspritebytepos = firstspritepos;

            for (int s = 0; s < SpriteCount; s++)
            {
                BW.Write((Byte)Spr_Hei[s]);
                BW.Write((Byte)((Spr_Wid[s] + 1) / 2));
                BW.Write((Byte)Spr_Yoff[s]);
                BW.Write((Byte)Spr_Xoff[s]);

                Int16 mp = (Int16)(thisspritebytepos);
                thisspritebytepos = thisspritebytepos + ((Spr_Hei[s] - Spr_MinY[s]) * ((Spr_Wid[s] + 1) / 2));
                BW.Write(mp);
                bytepos += 6;
            }
            while (bytepos < firstspritepos)
            {
                bytepos++;
                BW.Write((Byte)(0));
            }




            for (int spritenum = 0; spritenum < SpriteCount; spritenum++)
            {
                for (int y = Spr_MinY[spritenum]; y < Spr_Hei[spritenum]; y++)
                {
                    for (int x = 0; x < Spr_Wid[spritenum]; x += 2)
                    {
                        int sp1 = spritepixel[spritenum, x, y];
                        int sp2 = spritepixel[spritenum, x + 1, y];



                        if (sp1 == 16) sp1 = 0;
                        if (sp2 == 16) sp2 = 0;


                        string tbyte = "";

                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(4, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(5, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);

                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(4, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(5, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);



                        //int b1 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(0, 1) + VbX.Dec2Bin8Bit(b).Substring(4, 1));
                        //int b3 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(1, 1) + VbX.Dec2Bin8Bit(b).Substring(5, 1));
                        //int b2 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(2, 1) + VbX.Dec2Bin8Bit(b).Substring(6, 1));
                        //int b4 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(3, 1) + VbX.Dec2Bin8Bit(b).Substring(7, 1));

                        BW.Write((Byte)VbX.Bin2Dec(tbyte));



                    }
                }


            }

            BW.Close();
            ST.Close();
            //VbX.MsgBox("Saved");
            tabControl1.SelectedTab = tabControl1.TabPages[0];

            btnRefresh_Click(sender, e);
        }

        private void pasteZXToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string response = VbX.InputBox("Replace Sprite", "Replace Sprite", "yes/no");
            if (response != "*yes*") return;


            Bitmap clipbit = (Bitmap)Clipboard.GetImage();
            if (clipbit == null) return;
            for (int x = 0; x < 256; x += 8)
            {
                for (int y = 0; y < 256; y += 8)
                {
                    string[] ccol = new string[256];
                    int[] cct = new int[256];
                    int bestcolnum = 0;
                    string bestcol = "";
                    int bestcolnum2 = 0;
                    string bestcol2 = "";
                    for (int xx = x; xx < x + 8; xx++)
                    {
                        for (int yy = y; yy < y + 8; yy++)
                        {
                            Color c = Color.Black;

                            if (y < clipbit.Height && x < clipbit.Width)
                            {
                                c = clipbit.GetPixel(xx, yy);
                            }

                            int r = c.R / 16;
                            int g = c.G / 16;
                            int b = c.B / 16;
                            string thiscol = VbX.Hex(r) + VbX.Hex(g) + VbX.Hex(b);
                            for (int i = 0; i < 256; i++)
                            {
                                if (ccol[i] == thiscol)
                                {
                                    cct[i]++;
                                    if (cct[i] > bestcolnum)
                                    {
                                        bestcol = thiscol;
                                        bestcolnum = cct[i];
                                    }
                                    else if (cct[i] > bestcolnum2)
                                    {
                                        bestcol2 = thiscol;
                                        bestcolnum2 = cct[i];

                                    }
                                }
                                if (ccol[i] == "" || ccol[i] == null)
                                {
                                    cct[i]++;
                                    ccol[i] = thiscol;
                                    if (cct[i] > bestcolnum)
                                    {
                                        bestcol = thiscol;
                                        bestcolnum = cct[i];
                                    }

                                }
                                i = 1024;
                            }
                        }
                    }
                    // VbX.MsgBox(bestcol + "  " + bestcolnum);
                    Int16 c1 = 1;
                    Int16 c0 = 0;
                    if (((VbX.Val("&0" + bestcol) < VbX.Val("&0" + bestcol2))) || bestcol == "000")
                    {

                        c1 = 0;
                        c0 = 1;
                    }


                    SpeccyPaletteB[CurrentSprite, x / 8, y / 8] = 0;
                    SpeccyPaletteF[CurrentSprite, x / 8, y / 8] = 7;


                    for (int xx = x; xx < x + 8; xx++)
                    {
                        for (int yy = y; yy < y + 8; yy++)
                        {
                            Color c = Color.Black;

                            if (y < clipbit.Height && x < clipbit.Width)
                            {
                                c = clipbit.GetPixel(xx, yy);
                            }

                            int r = c.R / 16;
                            int g = c.G / 16;
                            int b = c.B / 16;
                            string thiscol = VbX.Hex(r) + VbX.Hex(g) + VbX.Hex(b);
                            if (bestcol == thiscol)
                            {
                                spritepixel[CurrentSprite, xx, yy] = c1;
                            }
                            else
                            {
                                spritepixel[CurrentSprite, xx, yy] = c0;
                            }

                        }

                    }

                }
            }
            rdoDisplaySpeccy.Checked = true;
            btnRefresh_Click(sender, e);
        }

        private void invertZXToolStripMenuItem_Click(object sender, EventArgs e)
        {
          
        }

        private void copyPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Clipboard.SetImage(bmpZoom);
        }

        private void canvasSizeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int mx = VbX.CInt(VbX.InputBox("New Width", "New Width", "0"));
            int my = VbX.CInt(VbX.InputBox("New Height", "New Height", "0"));
            if (my == 0 || mx == 0) return;
            for (int y = my; y < 256; y++)
            {
                for (int x = 0; x < 256; x++)
                {
                    spritepixel[CurrentSprite, x, y] = 0;
                }
            }


            for (int y = 0; y < 256; y++)
            {
                for (int x = mx; x < 256; x++)
                {
                    spritepixel[CurrentSprite, x, y] = 0;
                }
            }
        }

        private void loadCPCBinaryToolStripMenuItem_Click(object sender, EventArgs e)
        {

            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "Cpc Plus Binary Sprite (*.*)|*.*";
            DialogResult dr = fd.ShowDialog();
            ClearSprites();
            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Open, System.IO.FileAccess.Read);

            System.IO.BinaryReader BR = new System.IO.BinaryReader(ST);
            byte b = 0;
            if (chkHasDosHeader.Checked)
            {
                for (int i = 0; i < 128; i++)
                {
                    //skip header
                    b = BR.ReadByte();
                }
            }
            for (int s = 0; s < 16; s++)
            {
                for (int y = 0; y < 16; y++)
                {
                    for (int x = 0; x < 15; x += 2)
                    {
                        b = BR.ReadByte();
                        int b2 = b / 16;
                        int b1 = b % 16;
                        spritepixel[s, x, y] = (Int16)b1;
                        spritepixel[s, x + 1, y] = (Int16)b2;
                    }
                }
            }

            BR.Close();
            ST.Close();
            VbX.MsgBox("Loaded");
            btnRefresh_Click(sender, e);
        }

        private void loadCPCBinaryToolStripMenuItem1_Click(object sender, EventArgs e)
        {


            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "CPC Binary Sprite (*.*)|*.*";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;
            ClearSprites();
            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Open, System.IO.FileAccess.Read);

            System.IO.BinaryReader BR = new System.IO.BinaryReader(ST);
            byte b = 0;
            int firstspritepos = 0;
            int spritenum = 0;
            if (chkHasDosHeader.Checked)
            {
                for (int i = 0; i < 128; i++)
                {
                    //skip header
                    b = BR.ReadByte();
                }
            }

            while (firstspritepos == 0 || firstspritepos > ST.Position)
            {
                b = BR.ReadByte();
                Spr_Hei[spritenum] = (Int16)b;

                b = BR.ReadByte();
                Spr_Wid[spritenum] = (Int16)(b * 4);


                b = BR.ReadByte();
                Spr_Yoff[spritenum] = (Int16)b;
                b = BR.ReadByte();
                Spr_Xoff[spritenum] = (Int16)b;


                b = BR.ReadByte();
                int Mempos = (int)b;
                b = BR.ReadByte();
                Mempos += ((int)b * 256);


                spritenum++;

                if (firstspritepos == 0) firstspritepos = Mempos;
            }
            int spritecount = spritenum;

            for (spritenum = 0; spritenum < spritecount; spritenum++)
            {
                for (int y = 0; y < Spr_Hei[spritenum]; y++)
                {
                    for (int x = 0; x < Spr_Wid[spritenum]; x += 4)
                    {
                        b = BR.ReadByte();
                        int b1 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(4, 1) + VbX.Dec2Bin8Bit(b).Substring(0, 1));
                        int b2 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(5, 1) + VbX.Dec2Bin8Bit(b).Substring(1, 1));
                        int b3 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(6, 1) + VbX.Dec2Bin8Bit(b).Substring(2, 1));
                        int b4 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(7, 1) + VbX.Dec2Bin8Bit(b).Substring(3, 1));

                        int transpcol = VbX.Bin2Dec(VbX.Right(VbX.Dec2Bin8Bit(Spr_Xoff[spritenum]), 3));

                        if ((transpcol == 5 && b1 == 0 && b2 == 1 && b3 == 2 && b4 == 3) || (transpcol == 4 && b1 == 3 && b2 == 2 && b3 == 1 && b4 == 0))
                        {
                            b1 = 16;
                            b2 = 16;
                            b3 = 16;
                            b4 = 16;
                        }


                        spritepixel[spritenum, x, y] = (Int16)b1;
                        spritepixel[spritenum, x + 1, y] = (Int16)b2;
                        spritepixel[spritenum, x + 2, y] = (Int16)b3;
                        spritepixel[spritenum, x + 3, y] = (Int16)b4;



                        /*

                        int sp1 = spritepixel[spritenum, x, y];
                        int sp2 = spritepixel[spritenum, x + 1, y];
                        int sp3 = spritepixel[spritenum, x + 2, y];
                        int sp4 = spritepixel[spritenum, x + 3, y];
                        string tbyte = "";
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp3).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp4).Substring(6, 1);

                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp3).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp4).Substring(7, 1);
                        VbX.MsgBox(VbX.Dec2Bin8Bit(b) + "=" + tbyte);
                        */
                    }
                }
                SaveSpriteDetails(spritenum);
            }

            BR.Close();
            ST.Close();
            VbX.MsgBox("Loaded");

            txtSpriteDataOffSet.Text = "&" + VbX.Hex(firstspritepos);

            btnRefresh_Click(sender, e);
        }

        private void saveCPCBinaryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "CPC Binary Sprite (*.SPR)|*.SPR";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;


            int firstspritepos = VbX.Val(txtSpriteDataOffSet.Text);
            for (int s = 0; s < 64; s++)
            {
                SpriteStats(s);         // update all our info on the sprites
            }





            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Create, System.IO.FileAccess.Write);

            System.IO.BinaryWriter BW = new System.IO.BinaryWriter(ST);
            byte b = 0;
            int bytepos = 0;
            int thisspritebytepos = firstspritepos;

            for (int s = 0; s < SpriteCount; s++)
            {
                BW.Write((Byte)Spr_Hei[s]);
                BW.Write((Byte)((Spr_Wid[s] + 3) / 4));
                BW.Write((Byte)Spr_Yoff[s]);
                BW.Write((Byte)Spr_Xoff[s]);

                Int16 mp = (Int16)(thisspritebytepos);
                thisspritebytepos = thisspritebytepos + ((Spr_Hei[s] - Spr_MinY[s]) * ((Spr_Wid[s] + 3) / 4));
                BW.Write(mp);
                bytepos += 6;
            }
            while (bytepos < firstspritepos)
            {
                bytepos++;
                BW.Write((Byte)(0));
            }




            for (int spritenum = 0; spritenum < SpriteCount; spritenum++)
            {
                for (int y = Spr_MinY[spritenum]; y < Spr_Hei[spritenum]; y++)
                {
                    for (int x = 0; x < Spr_Wid[spritenum]; x += 4)
                    {
                        int sp1 = spritepixel[spritenum, x, y];
                        int sp2 = spritepixel[spritenum, x + 1, y];
                        int sp3 = spritepixel[spritenum, x + 2, y];
                        int sp4 = spritepixel[spritenum, x + 3, y];


                        if (sp4 == 16 && sp3 == 16 && sp2 == 16 && sp1 == 16)
                        {
                            int transpcol = VbX.Bin2Dec(VbX.Right(VbX.Dec2Bin8Bit(Spr_Xoff[spritenum]), 3));
                            if (transpcol == 5)
                            {
                                sp1 = 0;
                                sp2 = 1;
                                sp3 = 2;
                                sp4 = 3;
                            }
                            if (transpcol == 4)
                            {
                                sp1 = 3;
                                sp2 = 2;
                                sp3 = 1;
                                sp4 = 0;
                            }
                        }
                        if (sp1 == 16) sp1 = 0;
                        if (sp2 == 16) sp2 = 0;
                        if (sp3 == 16) sp3 = 0;
                        if (sp4 == 16) sp4 = 0;


                        string tbyte = "";

                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp3).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp4).Substring(7, 1);

                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp3).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp4).Substring(6, 1);




                        //int b1 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(0, 1) + VbX.Dec2Bin8Bit(b).Substring(4, 1));
                        //int b3 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(1, 1) + VbX.Dec2Bin8Bit(b).Substring(5, 1));
                        //int b2 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(2, 1) + VbX.Dec2Bin8Bit(b).Substring(6, 1));
                        //int b4 = VbX.Bin2Dec(VbX.Dec2Bin8Bit(b).Substring(3, 1) + VbX.Dec2Bin8Bit(b).Substring(7, 1));

                        BW.Write((Byte)VbX.Bin2Dec(tbyte));



                    }
                }


            }

            BW.Close();
            ST.Close();
            //VbX.MsgBox("Saved");
            tabControl1.SelectedTab = tabControl1.TabPages[0];

            btnRefresh_Click(sender, e);
        }

        private void saveSpritesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "Text Sprite Data (*.txt)|*.txt";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;

            string nl = VbX.Chr(13) + VbX.Chr(10);
            System.IO.StreamWriter SR = new System.IO.StreamWriter(fd.FileName, false, Encoding.ASCII);

            SR.Write("FileVersion,1" + nl);
            SR.Write("Sprites,64" + nl);

            for (int i = 0; i <= 16; i++)
            {
                SR.Write("Colorselector," + i.ToString());
                SR.Write("," + ColorSelector[i].BackColor.R.ToString());
                SR.Write("," + ColorSelector[i].BackColor.G.ToString());
                SR.Write("," + ColorSelector[i].BackColor.B.ToString());
                SR.Write(nl);
            }
            for (int s = 0; s < 64; s++)
            {
                SpriteStats(s);         // update all our info on the sprites
            }

            SR.Write("SpriteStart" + nl);
            for (int s = 0; s < SpriteCount; s++)
            {

                SR.Write("SpriteBitmapBlock," + s.ToString() + "," + Spr_Hei[s].ToString() + "," + Spr_Wid[s].ToString() + nl);
                for (int y = 0; y < Spr_Hei[s]; y++)
                {
                    for (int x = 0; x < Spr_Wid[s]; x++)
                    {
                        if (x > 0) SR.Write(",");
                        SR.Write(spritepixel[s, x, y].ToString());
                    }
                    SR.Write(VbX.Chr(13) + VbX.Chr(10));
                }
                SR.Write("SpriteSpeccyBlock," + s.ToString() + "," + (Spr_Hei[s] / 8).ToString() + "," + (Spr_Wid[s] / 8).ToString() + nl);
                for (int y = 0; y < Spr_Hei[s] / 8; y++)
                {
                    for (int x = 0; x < Spr_Wid[s] / 8; x++)
                    {
                        if (x > 0) SR.Write(",");
                        SR.Write(SpeccyPaletteF[s, x, y].ToString() + ",");
                        SR.Write(SpeccyPaletteB[s, x, y].ToString() + ",");
                        SR.Write(SpeccyPaletteL[s, x, y].ToString());
                    }
                    SR.Write(VbX.Chr(13) + VbX.Chr(10));
                }
            }

            //        public Int16[,,] spritepixel;
            //public Int16[, ,] SpeccyPaletteF;   //foreground
            //public Int16[, ,] SpeccyPaletteB;   //Background
            //public Int16[, ,] SpeccyPaletteL;   //Lightness
            SR.Write("SpriteDataOffSet," + txtSpriteDataOffSet.Text + nl);


            SR.Write("eof" + nl);
            SR.Close();
            //VbX.MsgBox("Save Complete");
            tabControl1.SelectedTab = tabControl1.TabPages[0];
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {

        }

        private void savePaletteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "Text Palette Data (*.txt)|*.txt";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;

            string nl = VbX.Chr(13) + VbX.Chr(10);
            System.IO.StreamWriter SR = new System.IO.StreamWriter(fd.FileName, false, Encoding.ASCII);

            SR.Write("FileVersion,1" + nl);
            SR.Write("Sprites,0" + nl);

            for (int i = 0; i < 16; i++)
            {
                SR.Write("Colorselector," + i.ToString());
                SR.Write("," + ColorSelector[i].BackColor.R.ToString());
                SR.Write("," + ColorSelector[i].BackColor.G.ToString());
                SR.Write("," + ColorSelector[i].BackColor.B.ToString());
                SR.Write(nl);
            }
            SR.Close();
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {

            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "Text Sprite Data (*.txt)|*.txt";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;

            int spriteresetdone = 0;

            System.IO.StreamReader SR = new System.IO.StreamReader(fd.FileName);
            int s = 0;

            string lin2 = "";    // read dummy line
            lin2 = SR.ReadLine();       // read dummy line
            while (ss.GetItem(lin2, ",", 0).ToLower() != "eof" && !SR.EndOfStream)
            {

                string command = ss.GetItem(lin2, ",", 0).ToLower();
                int sprite = VbX.CInt(ss.GetItem(lin2, ",", 1).ToLower());
                if (command == "colorselector")
                {
                    ColorSelector[sprite].BackColor = Color.FromArgb(VbX.CInt(ss.GetItem(lin2, ",", 2).ToLower()), VbX.CInt(ss.GetItem(lin2, ",", 3).ToLower()), VbX.CInt(ss.GetItem(lin2, ",", 4).ToLower()));

                }

                if (command == "spritebitmapblock")
                {

                    if (spriteresetdone == 0)
                    {
                        ClearSprites();
                        CurrentSprite = 0;
                        spriteresetdone = 1;
                    }
                    int maxy = VbX.CInt(ss.GetItem(lin2, ",", 2).ToLower());
                    for (int y = 0; y < maxy; y++)
                    {
                        string lin = SR.ReadLine();
                        for (int x = 0; x < 256; x++)
                        {
                            spritepixel[sprite, x, y] = (Int16)VbX.CInt(ss.GetItem(lin, ",", x));
                        }
                    }

                }
                if (command == "spritedataoffSet")
                {
                    txtSpriteDataOffSet.Text = ss.GetItem(lin2, ",", 1).ToLower();
                }

                if (command == "spritespeccyblock")
                {
                    int maxy = VbX.CInt(ss.GetItem(lin2, ",", 2).ToLower());
                    int maxx = VbX.CInt(ss.GetItem(lin2, ",", 3).ToLower());
                    sprite = VbX.CInt(ss.GetItem(lin2, ",", 1).ToLower());
                    for (int y = 0; y < maxy; y++)
                    {
                        string lin = SR.ReadLine();
                        for (int x = 0; x < 32; x++)
                        {

                            SpeccyPaletteF[sprite, x, y] = (Int16)VbX.CInt(ss.GetItem(lin, ",", x * 3 + 0));
                            SpeccyPaletteB[sprite, x, y] = (Int16)VbX.CInt(ss.GetItem(lin, ",", x * 3 + 1));
                            SpeccyPaletteL[sprite, x, y] = (Int16)VbX.CInt(ss.GetItem(lin, ",", x * 3 + 2));

                            //SR.Write(SpeccyPaletteF[s, x, y].ToString() + ",");
                            //SR.Write(SpeccyPaletteB[s, x, y].ToString() + ",");
                            //SR.Write(SpeccyPaletteL[s, x, y].ToString());
                        }
                    }

                }
                lin2 = SR.ReadLine();       // read dummy line
            }
            tabControl1.SelectedTab = tabControl1.TabPages[0];
            // VbX.MsgBox("Load Complete");

            //        public Int16[,,] spritepixel;
            //public Int16[, ,] SpeccyPaletteF;   //foreground
            //public Int16[, ,] SpeccyPaletteB;   //Background
            //public Int16[, ,] SpeccyPaletteL;   //Lightness
            SR.Close();

            btnRefresh_Click(sender, e);
        }

        private void copyToClipboardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Bitmap clipbit = new Bitmap(256, 256);
            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {
                    clipbit.SetPixel(x, y, ColorSelector[spritepixel[CurrentSprite, x, y]].BackColor);
                }
            }

            Clipboard.SetImage(clipbit);
        }

        private void pasteToClipToolStripMenuItem_Click(object sender, EventArgs e)
        {

            Bitmap clipbit = (Bitmap)Clipboard.GetImage();
            if (clipbit == null) return;
            string response = VbX.InputBox("Replace Sprite", "Replace Sprite", "yes/no");
            if (response != "*yes*") return;


            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {
                    Color c = Color.Black;

                    if (y < clipbit.Height && x < clipbit.Width)
                    {
                        c = clipbit.GetPixel(x, y);
                    }


                    int currentpixel = 0;
                    int bestpixel=255*255*255;
                    

                    

                    for (int i = 0; i < 16; i++)
                    {
                        int thisdiff = Math.Abs(ColorSelector[i].BackColor.R - c.R) + Math.Abs(ColorSelector[i].BackColor.G - c.G) + Math.Abs(ColorSelector[i].BackColor.B - c.B);

                        if (thisdiff<bestpixel) {
                            bestpixel=thisdiff;
                            currentpixel=i;
                        }
                            
                    }
                    spritepixel[CurrentSprite, x, y] = (Int16)currentpixel;    
                }
            }
            btnRefresh_Click(sender, e);
            
        }

        private void fourColor2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {

                    Int16 i=spritepixel[CurrentSprite, x, y] ;
                    switch (i) { 
                        case 1:
                            i = checkerize(x, y, 3, 0, 1);
                            break;
                        case 2:
                            i = checkerize(x, y, 3, 0, 2);
                            break;
                    }

                    spritepixel[CurrentSprite, x, y] = i;

                }
            }
        }

        private void invertZXToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            string response = VbX.InputBox("Replace Sprite", "Replace Sprite", "yes/no");
            if (response != "*yes*") return;


            Bitmap clipbit = (Bitmap)Clipboard.GetImage();
            if (clipbit == null) return;
            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {
                    Color c = Color.Black;

                    if (y < clipbit.Height && x < clipbit.Width)
                    {
                        c = clipbit.GetPixel(x, y);
                    }

                    for (int i = 0; i < 16; i++)
                    {
                        if (ColorSelector[i].BackColor.R == c.R && ColorSelector[i].BackColor.G == c.G && ColorSelector[i].BackColor.B == c.B)
                        {
                            spritepixel[CurrentSprite, x, y] = (Int16)i;
                        }
                    }
                }
            }
            btnRefresh_Click(sender, e);
            
        }

        private void chkStrongGrid_CheckedChanged(object sender, EventArgs e)
        {
            btnRefresh_Click(sender, e);
        }

        private void saveSpectrumScreenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "ZXS Binary Sprite (*.SCR)|*.SCR";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;


            int firstspritepos = VbX.Val(txtSpriteDataOffSet.Text);
            for (int s = 0; s < 64; s++)
            {
                SpriteStats(s);         // update all our info on the sprites
            }





            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Create, System.IO.FileAccess.Write);

            System.IO.BinaryWriter BW = new System.IO.BinaryWriter(ST);
            byte b = 0;
            int bytepos = 0;
            int thisspritebytepos = firstspritepos;

            int spritenum = CurrentSprite;

            int yy = 0;
            int x = 0;


            for (int by = 0; by < (256 * 192) / 8; by++)
            {
                int y1 = yy % 8 * 8;
                int y2 = (yy % 64) / 8;
                int y3 = (yy / 64) * 64;
                int y = y1 + y2 + y3;

                int sp1 = spritepixel[spritenum, x, y];
                int sp2 = spritepixel[spritenum, x + 1, y];
                int sp3 = spritepixel[spritenum, x + 2, y];
                int sp4 = spritepixel[spritenum, x + 3, y];
                int sp5 = spritepixel[spritenum, x + 4, y];
                int sp6 = spritepixel[spritenum, x + 5, y];
                int sp7 = spritepixel[spritenum, x + 6, y];
                int sp8 = spritepixel[spritenum, x + 7, y];

                string tbyte = "";

                tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp3).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp4).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp5).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp6).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp7).Substring(7, 1);
                tbyte += VbX.Dec2Bin8Bit(sp8).Substring(7, 1);





                BW.Write((Byte)VbX.Bin2Dec(tbyte));
                x = x + 8;
                if (x == 256) { x = 0; yy++; }
            }
                for (int y =0; y < (192 / 8); y++)
                {
                    for (x = 0; x < (256/ 8); x++)
                    {
                        string tbyte = "0"; //flashing is bad -mkay!
                        tbyte += VbX.Dec2Bin8Bit(SpeccyPaletteL[spritenum, x, y]).Substring(7, 1);
                        tbyte += VbX.Dec2Bin8Bit(SpeccyPaletteB[spritenum, x, y]).Substring(5, 3);
                        tbyte += VbX.Dec2Bin8Bit(SpeccyPaletteF[spritenum, x, y]).Substring(5, 3);
                        BW.Write((Byte)VbX.Bin2Dec(tbyte));

                    }
                }
            

            BW.Close();
            ST.Close();
            //VbX.MsgBox("Saved");
            tabControl1.SelectedTab = tabControl1.TabPages[0];

            btnRefresh_Click(sender, e);
        }

        private void saveMSXBitmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "MSX Bitmap Screen/Sprite (*.SCR)|*.SCR";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;


               


            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Create, System.IO.FileAccess.Write);

            System.IO.BinaryWriter BW = new System.IO.BinaryWriter(ST);
            int spritenum = CurrentSprite;

            

            BW.Write((Byte)(0));         // First byte = format: 0= no palette 1 = palette
            BW.Write((Byte)(Spr_Wid[spritenum]));         // Width
            BW.Write((Byte)(Spr_Hei[spritenum]));         // Height

                for (int y = Spr_MinY[spritenum]; y < Spr_Hei[spritenum]; y++)
                {
                    for (int x = 0; x < Spr_Wid[spritenum]; x += 2)
                    {
                        int sp1 = spritepixel[spritenum, x, y];
                        int sp2 = spritepixel[spritenum, x + 1, y];

                        if (sp1 == 16) sp1 = 0;
                        if (sp2 == 16) sp2 = 0;
                        string tbyte = "";
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(4, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(5, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);

                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(4, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(5, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(6, 1);
                        tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);

                        BW.Write((Byte)VbX.Bin2Dec(tbyte));
                    }
                }
        
            BW.Close();
            ST.Close();
            tabControl1.SelectedTab = tabControl1.TabPages[0];

            btnRefresh_Click(sender, e);
        }

        private void saveMSXBitmapWithPaletteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "MSX Bitmap Screen/Sprite (*.SCR)|*.SCR";
            DialogResult dr = fd.ShowDialog();
            if (dr != DialogResult.OK) return;





            System.IO.Stream ST = new System.IO.FileStream(fd.FileName, System.IO.FileMode.Create, System.IO.FileAccess.Write);

            System.IO.BinaryWriter BW = new System.IO.BinaryWriter(ST);
            int spritenum = CurrentSprite;



            BW.Write((Byte)(1));         // First byte = format: 0= no palette 1 = palette
            BW.Write((Byte)(Spr_Wid[spritenum]));         // Width
            BW.Write((Byte)(Spr_Hei[spritenum]));         // Height





            for (int i = 0; i < 16; i++)
            {
                string tbyte = "";
                tbyte = "0" + VbX.Dec2Bin8Bit(ColorSelector[i].BackColor.R).Substring(0, 3) + "0" + VbX.Dec2Bin8Bit(ColorSelector[i].BackColor.B).Substring(0, 3);
                BW.Write((Byte)VbX.Bin2Dec(tbyte));
                tbyte = "00000" + VbX.Dec2Bin8Bit(ColorSelector[i].BackColor.G).Substring(0, 3);
                BW.Write((Byte)VbX.Bin2Dec(tbyte));

            }
                



            for (int y = Spr_MinY[spritenum]; y < Spr_Hei[spritenum]; y++)
            {
                for (int x = 0; x < Spr_Wid[spritenum]; x += 2)
                {
                    int sp1 = spritepixel[spritenum, x, y];
                    int sp2 = spritepixel[spritenum, x + 1, y];

                    if (sp1 == 16) sp1 = 0;
                    if (sp2 == 16) sp2 = 0;
                    string tbyte = "";
                    tbyte += VbX.Dec2Bin8Bit(sp1).Substring(4, 1);
                    tbyte += VbX.Dec2Bin8Bit(sp1).Substring(5, 1);
                    tbyte += VbX.Dec2Bin8Bit(sp1).Substring(6, 1);
                    tbyte += VbX.Dec2Bin8Bit(sp1).Substring(7, 1);

                    tbyte += VbX.Dec2Bin8Bit(sp2).Substring(4, 1);
                    tbyte += VbX.Dec2Bin8Bit(sp2).Substring(5, 1);
                    tbyte += VbX.Dec2Bin8Bit(sp2).Substring(6, 1);
                    tbyte += VbX.Dec2Bin8Bit(sp2).Substring(7, 1);

                    BW.Write((Byte)VbX.Bin2Dec(tbyte));
                }
            }

            BW.Close();
            ST.Close();
            tabControl1.SelectedTab = tabControl1.TabPages[0];

            btnRefresh_Click(sender, e);
        }



    }
}
